C
C      THIS INCLUDE FILE CONTAINS ALL THE KEYWORD FLAGS AND THEIR ASSOCIATED
C      VALUES
C
C      KEYWORD FLAGS ARE INTEGERS THAT BEGIN WITH 'I' AND ARE FOLLOWED
C      BY THE FIRST 5 LETTERS OF THE KEYWORD (OR FEWER IF THE KEYWORD
C      IS SMALLER).  EXCEPTIONS SHOULD BE LISTED IN THE INCLUDE FILE
C      'KEYS.i'
C
C      NON-ALPHANUMERICS SUCH AS '.' AND '/' ARE OMITTED.
C
C      VALUES FOR KEYWORDS THAT CONTAIN MORE THAT ONE ARGUMENT (THERMO,
C      OPEN) CONTAIN THE NUMBER OF THE ARGUMENT AS THE LAST DIGIT.  IE.
C      THE TWO VALUES ASSOCIATED WITH OPEN ARE STORED IN IIOPE1 AND IIOPE2.
C
C   EXCEPTIONS:
C     KEYWORD    FLAG
C     RAD        IRAD1
C     DEBUGPULAY IDEBUP
C     TRUSTG     ITRUSG                                                 DJG0496
C     TRUSTE     ITRUSE                                                 DJG0496
C     HFOPT,HF1SCF IHF                                                  DJG0496
C
C     KEYWORD   VALUE FLAG
C     STEP1     FISTE1
C     STEP2     FISTE2
C     NDOTEP    IIDOTE
C     NDOTCD    IIDOTC
C     NDIVEP    IIDIVE
C     NDIVCD    IIDIVC
C
C
C   SOME KEYWORDS CAN TAKE MORE VALUES THAN JUST 0 OR 1.  THESE ARE
C   LISTED HERE -
C
C     THERMO
C       1 - NO ASSOCIATED VALUE GIVEN ON KEYWORD LINE
C       2 - ONE ASSOCIATED VALUE GIVEN ON KEYWORD LINE
C       3 - TWO ASSOCIATED VALUES GIVEN ON KEYWORD LINE
C       4 - THREE ASSOCIATED VALUES GIVEN ON KEYWORD LINE
C
C     RESTART, STDM
C       1 - INCLUDED ON KEYWORD LINE IN .DAT FILE
C      -1 - NEEDS TO BE ADDED TO KEYWORD LINE                           GDH1195
C      -2 - ADDED TO KEYWORD LINE DURING CALCULATION
C
C     SM1, SM2, SM3, SM4, SM5x, SM1A, SM2.1, SM3.1, OSM5x, PDSMx        DJG0396
C       1 - INCLUDED ON KEYWORD LINE
C      -1 - INCLUDED ON KEYWORD LINE, BUT CURRENTLY DOING THE GAS-PHASE
C           PORTION OF A TRUES/CALC RUN.
C
C     DRC, H-PRIORITY, T-PRIORITY, X-PRIORITY, KICK, TRANS
C       1 - INCLUDED ON KEYWORD LINE WITH NO ASSOCIATED VALUE
C       2 - INCLUDED ON KEYWORD LINE WITH AN ASSOCIATED VALUE
C
C     TRUES
C       1 - INCLUDED ON THE KEYWORD LINE
C       2 - INCLUDED ON THE KEYWORD LINE WITH HFCALC                    GDH1/96
C       1 - INCLUDED ON THE KEYWORD LINE WITH HFOPT OR HF1SCF
C           (After call to KWNONO)
C
C     HFCALC=                                                           GDH1/96
C       1 - HFCALC=OPT TURNED ON BY DEFAULT                             GDH1/96
C       2 - INCLUDED ON THE KEYWORD LINE AS HFCALC=OPT                  GDH1/96
C       3 - INCLUDED ON THE KEYWORD LINE AS HFCALC=1SCF                 GDH1/96
C
C     HFOPT=, HF1SCF=                                                   GDH0196
C       1 - HFOPT= INCLUDED ON THE KEYWORD LINE WITH A VALUE            GDH1/96
C       2 - HF1SCF= INCLUDED ON THE KEYWORD LINE WITH A VALUE           GDH1/96
C      -2 - INCLUDED ON KEYWORD LINE, BUT TRUES KEYWORD IS NOT USED     GDH1195
C      -3 - HF=x NEEDS TO BE ADDED AND HFCALC NEEDS TO BE REMOVED       GDH1/96
C      -4 - HF=x ADDED TO KEYWORD LINE (BUT HFCALC NEEDS TO BE          GDH1/96
C           REMOVED)                                                    GDH1195
C      -5 - HFCALC REMOVED (BUT HF=x NEEDS TO BE ADDED)                 GDH1/96
C      -6 - HF KEYWORD HAS BEEN ADJUSTED                                GDH1195
C      -7 - ERROR, BOTH INCLUDED ON KEYWORD LINE                        GDH1/96
C
      COMMON /SVMDWD/ ISM4, ISM21, ISM31, ISM2, ISM3, ISM1,ISM1A,       DJG0496
     1                ISM22, IPDS5U, IPDS5A, IPDS5P, ISM23, IGPGCD,     DJG0796
     2                ISM5A, ISM5P, ISM5U, IOSM5A, IOSM5P, IOSM5U,      DJG0796
     3                IS5A2P, IS5P2P, ISM50, ISM505, ISM52R, ISM54R,    GDH0997
     4                ISM52, ISM542                                     PDW1099
      COMMON /CONVWD/ ICS1, ICS2, ICS3, ISCFCR, IGCOMP, IGNORM,
     1                IPRECI, IPULAY, ICAMPK, ISHIFT, IFULSC, IFAIL,
     2                IITRY, IFORWR
      COMMON /OPMTWD/ INEWTO, IPOWEL, IBFGS, IDFP, IEFOLL, ITSTAT,
     1                ISIGMA, INLLSQ, ILTRD, ISADDL, ICHAIN, ITRUSG,    DJG0496
     2                ITRUSE                                            DJG0496
      COMMON /GEOPWD/ IOPT, I0SCF, I1SCF, IGEOOK, INOPOL, IERASE        PDW1199
      COMMON /THRMWD/ IFORCE, ITHERM, IROT, ITRANS
      COMMON /AMPCWD/ ISTEP1, ISTEP2, IMULLI, IPISIG, IENPAR, IPOLAR
      COMMON /PATHWD/ IPATH, IWEIGH, ITV
      COMMON /DBUGWD/ IPRINT, IDEBUG, IDEBUP, IFLEPO, IFMAT, IITER,
     1                ICOMPF, IDERI1, IDERI2, IDERIV, IHCORE, ILINMI,
     2                ILOCMI, IMOLDA, IPOWSQ, IDCART, IEIGS, IPLITE,
     3                ISEARC, ITIMES, IINTER
      COMMON /RDWTWD/ IDENMA, IDENOU, IDENSI, IDFORC, IEXTER, IFOCK,
     1                IGRADI, IGRAPH, IISOTO, ILOCAL, IMECI, INOINT,
     2                INOXYZ, IOLDEN, IOLDMA, IVECTO, IBONDS, I1ELEC,
     3                INOREF, IDFPSA, IDEP, ISPIN, IINPUT, INOINP,
     4                ISPART, IPRGEO, IPRCOU, IPRRAD, IPRPOL            PDW1199
      COMMON /CIWD  / ICI, IROOT, IMICRO, ICIS                          DL0397
      COMMON /STATWD/ IUHF, IOPEN, ISINGL, IDOUBL, ITRIPL, IQUART,
     1                IQUINT, ISEXTE, IBIRAD, IEXCIT, IFILL
      COMMON /ELECWD/ IESR, IHYPER
      COMMON /HAMWD / IAM1, IPM3, IMNDOC, IMINDO, IMNDO, IGAS
      COMMON /DRCWD / IDRC, IKINET, IHPRIO, ITPRIO, IXPRIO
      COMMON /SVNTWD/ ISOLVN, IMSURF, IDIELE, ISVCDR, ISVCSR, INOCOG,   DJG0396
     1                IIOFR, IALPHA, IBETA, IGAMMA, IFACAR, IFEHAL      GDH0797
      COMMON /EXTSWD/ IEXTSM, IEXTCM, IEXTM, ISTDM, IXKW
      COMMON /ACCTWD/ IRESTA, ICYCLE, ITLIMI, ITDUMP
      COMMON /OPTWD / IDERIN, IDERIS, ISYMME, IXYZ, IKICK, ICART
      COMMON /MISCWD/ ILET, ICHARG, ITRUES, IHF, IHFCAL, IBAR, IDEV,
     1                IVOLUM, INOVOL, ICM1, IAREAS, IDEPVA, ICM2,       GDH0997
     2                ICM3                                              !JT0802
      COMMON /EFWD  / INONR, IHESS, IMODE, IRSCAL, IDMAX, IOMIN,
     1                IRMIN, IRMAX, IDDMAX, IDDMIN, IRECAL, IIUPD,
     2                IGNMIN
      COMMON /SCONWD/ IDOTS, IGEPOL, IRAD1, ITEXPN, INDIVC,
     1                INDIVE, INDOTC, INDOTE, IASA, ITONE
      COMMON /FVALWD/ FISCFC, FIGCOM, FIGNOR, FISHIF, FISTE1, FISTE2,
     1                FIDRC, FIKINE, FIMSUR, FIDIEL, FISVCD, FISVCS,
     2                FIBAR, FIDEPV, FIDMAX, FIOMIN, FIRMIN, FIRMAX,
     3                FIDDMA, FIDDMI, FITEXP, FITONE, FIHPRI, FITPRI,
     4                FIXPRI, FITLIM, FITDUM, FIHF, FIIOFR, FIALPH,     DJG0396
     5                FIBETA, FIGAMM, FFACAR, FFEHAL                    GDH0797
      COMMON /IVALWD/ IIIUPD, IIROT, IIPRIN, IICI, IIROOT, IIMICR,
     1                IIOPE1, IIOPE2, IIFILL, IICYCL,
     2                IIKICK, IICHAR, IIHESS, IIMODE, IIRECA, IIDIVC,
     3                IIDIVE, IIDOTC, IIDOTE, IITHE1, IITHE2, IITHE3,
     4                IIRAD, IIITRY, IITRAN
      COMMON /CVALWD/ CIEXTE, CISOLV

      CHARACTER CIEXTE*20, CISOLV*7                                     DJG0297

