      SUBROUTINE FREQCY(FMATRX,FREQ,CNORML,REDMAS) 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z) 
       INCLUDE 'SIZES.i'
********************************************************************* 
* 
*  FRCE CALCULATES THE FORCE CONSTANTS AND VIBRATIONAL FREQUENCIES 
*       FOR A MOLECULE.  IT USES THE ISOTOPIC MASSES TO WEIGHT THE 
*       FORCE MATRIX 
* 
* ON INPUT   FMATRX   =  FORCE MATRIX, OF SIZE NUMAT*3*(NUMAT*3+1)/2. 
* 
********************************************************************* 
      COMMON /MLKSTI/ NUMAT,NAT(NUMATM),NFIRST(NUMATM),NMIDLE(NUMATM),  3GL3092
     1                NLAST(NUMATM), NORBS, NELECS,NALPHA,NBETA,        3GL3092
     2                NCLOSE,NOPEN,NDUMY                                3GL3092
      COMMON /ATMASS/ ATMASS(NUMATM) 
C     COMMON /SCRACH/ OLDF(MAXHES), DUMMY(MAXPAR**2-MAXHES) 
C
C     /SCRACH/ HAS BEEN CONVERTED TO /SCRCHR/ AND /SCRCHI/ FOR AMSOL    
      COMMON /SCRCHR/ OLDF(MAXHES), DUMMY(6*MAXPAR**2+1-MAXHES)         GCL0393
C
      DIMENSION FMATRX(*), REDMAS(*), FREQ(*), CNORML(*) 
      DIMENSION WTMASS(MAXPAR), SHIFT(6) 
       SAVE
      DATA FACT/6.023D23/ 
C 
C    CONVERSION FACTOR FOR SPEED OF LIGHT AND 2 PI. 
C 
      C2PI=1.D0/(2.998D10*3.141592653598D0*2.D0) 
C NOW TO CALCULATE THE VIBRATIONAL FREQUENCIES 
C 
C   FIND CONVERSION CONSTANTS FOR MASS WEIGHTED SYSTEM 
      N3=3*NUMAT 
      L=0 
      DO 10 I=1,NUMAT 
         WEIGHT=1.4142136D0/SQRT(ATMASS(I)) 
         DO 10 J=1,3 
            L=L+1 
   10 WTMASS(L)=WEIGHT 
C    CONVERT TO MASS WEIGHTED FMATRX 
      LINEAR=0 
      DO 20 I=1,N3 
         DO 20 J=1,I 
            LINEAR=LINEAR+1 
            OLDF(LINEAR)=  FMATRX(LINEAR)*1.D5 
   20 FMATRX(LINEAR)=FMATRX(LINEAR)*WTMASS(I)*WTMASS(J) 
C 
C    1.D5 IS TO CONVERT FROM MILLIDYNES/ANGSTROM TO DYNES/CM. 
C 
C    DIAGONALIZE 
      CALL FRAME(FMATRX,NUMAT,1, SHIFT) 
      CALL HQRII(FMATRX,N3,N3,FREQ,CNORML) 
      DO 30 I=1,N3 
         J=(FREQ(I)+50.D0)*0.01D0 
   30 FREQ(I)=FREQ(I)-J*100 
      DO 40 I=1,N3 
   40 FREQ(I)=FREQ(I)*1.D5 
C 
C    CALCULATE REDUCED MASSES, STORE IN REDMAS 
C 
      DO 80 I=1,N3 
         II=(I-1)*N3 
         SUM=0.D0 
         DO 70 J=1,N3 
            JII=J+II 
            JJ=(J*(J-1))/2 
            DO 50 K=1,J 
   50       SUM=SUM+CNORML(JII)*OLDF(JJ+K)*CNORML(K+II) 
            DO 60 K=J+1,N3 
   60       SUM=SUM+CNORML(JII)*OLDF((K*(K-1))/2+J)*CNORML(K+II) 
   70    CONTINUE 
         IF(ABS(FREQ(I)).GT.ABS(SUM)*1.D-20) THEN 
            SUM=1.D0*SUM/FREQ(I) 
         ELSE 
            SUM=0.D0 
         ENDIF 
         IF(SUM.LT.0.D0.OR.SUM.GT.1.D2)SUM=0.D0 
   80 REDMAS(I)=SUM 
C 
C    SWITCH EIGENVALUES TO FREQUENCIES 
      DO 90 I=1,N3 
   90 FREQ(I)=SIGN(SQRT(FACT*ABS(FREQ(I)))*C2PI,FREQ(I)) 
C 
C    CONVERT NORMAL VECTORS TO CARTESIAN COORDINATES 
      IJ=0 
      DO 120 I=1,N3 
         SUM=0.D0 
         DO 100 J=1,N3 
            IJ=IJ+1 
            CNORML(IJ)=CNORML(IJ)*WTMASS(J) 
  100    SUM=SUM+CNORML(IJ)**2 
         SUM=1.D0/SQRT(SUM) 
         IJ=IJ-N3 
         DO 110 J=1,N3 
            IJ=IJ+1 
  110    CNORML(IJ)=CNORML(IJ)*SUM 
  120 CONTINUE 
      RETURN 
      END 
